program datenbank(dateiname);
uses
  crt, printer, vlado1;
const
  VersionText = 'Version 1.23 - Vlado Plaga 1998-2000';
type
  MenuText = array[1..8] of string;
  zeiger = ^daten;
  datensatz = record
                name: string[20];
                tel: string[19];
                strasse: string[20];
                stadt: string[20];
              end;
  daten = record
            inhalt: datensatz;
            vor, zurueck: zeiger;
          end;
var
  anker: zeiger;
  m: Array[1..4] Of Word;
  test: boolean;

procedure loescheAlle;
var
  lauf, temp: zeiger;
begin
  lauf:= anker;
  write('Speicher freigeben...');
  while lauf <> nil do
  begin
    write('.');
    temp:= lauf;
    lauf:= lauf^.vor;
    dispose(temp);
  end;
  textcolor(green);
  writeln(' fertig');
  textcolor(lightgray);
end;

function zaehlen: word;
var i: word; lauf: zeiger;
begin
  if anker <> nil then
    begin
      i:=1;
      lauf:=anker;
      while lauf^.vor <> nil do
        begin
          inc(i);
          lauf:=lauf^.vor;
        end;
    end
   else i:=0;
  zaehlen:=i;
end;

procedure angucken;
var
  lauf: zeiger;
  i: byte;
begin
  lauf:=anker;
  i:=1;
  while ((lauf<>nil)and(i<22)) do
    begin
      inc(i);
      writeln(lauf^.inhalt.name);
      lauf:=lauf^.vor;
    end;
end;

procedure loeschen(element: zeiger);
begin
  if anker = element then   {Sonderfall erstes Element}
  begin
    anker:= anker^.vor;
    if anker <> nil then anker^.zurueck:= nil;
  end
  else
  begin
    if element^.zurueck <> nil then element^.zurueck^.vor:= element^.vor;
    if element^.vor <> nil then element^.vor^.zurueck:= element^.zurueck;
  end;
  dispose(element);
end;

procedure durchsehen(dateiname:string);
var
  lauf,position,bildanf,bildend:zeiger;
  i:word;
  ch:char;
  mausx,mausy:byte;
  function abstand(anfang:zeiger;groesse:byte):zeiger;
  begin
    lauf:=anker;
    i:=0;
    while ((i<=groesse)and(lauf^.vor<>nil)) do
      begin
        inc(i);
        lauf:=lauf^.vor;
      end;
    abstand:=lauf;
  end;
  procedure datensatz_bearbeiten;
  var hilf:string;
  begin
    window(10,10,70,13); textbackground(red); csron; clrscr;
    write(^j,' ');
    case upcase(ch) of
      'N':begin
            write('Wie soll ',position^.inhalt.name,' jetzt heien? ');
            readln(hilf);
            if hilf ='' then
            begin
              write(' Jedes Element muss einen Namen haben! >Enter< drcken...');
              readln;
            end
            else position^.inhalt.name:=hilf;
          end;
      'T':begin
            write('Wie ist die Telefonnummer von ',position^.inhalt.name,'? ');
            readln(position^.inhalt.tel);
          end;
      'A':begin
            write('In welcher Strae wohnt ',position^.inhalt.name,'? ');
            readln(position^.inhalt.strasse);
          end;
      'W':begin
            write('Wie heit die PLZ /Stadt von ',position^.inhalt.name,'? ');
            readln(position^.inhalt.stadt);
          end;
     end;
    textbackground(black); clrscr; window(1,1,80,25); csroff;
  end;
  procedure schreibe(wort:string);
  begin
    textbackground(red);
    write(' ',wort,' ');
    textbackground(blue);
    write(' ');
  end;
begin
  textcolor(lightgreen); gotoxy(23,wherey);
  writeln(nur_name(dateiname),' - ',zaehlen,' Elemente'); textcolor(lightgray);
  for i:=1 to 80 do write('');
  write(' Name:               Telefonnummer:      Adresse:            Wohnort:');
  textcolor(lightgreen);
  gotoxy(2,wherey);write('N');gotoxy(22,wherey);write('T');
  gotoxy(42,wherey);write('A');gotoxy(62,wherey);write('W');
  textcolor(lightgray);
  window(1,25,80,25);textbackground(blue);clrscr;
  write(' Tasten:   a..z  ');
  schreibe('Esc'); write('  '); schreibe('Entf'); write('  '); schreibe('');
  schreibe(''); write('  '); schreibe('N'); schreibe('T'); schreibe('A');
  schreibe('W'); write('...fr Mausklicks!');
  window(1,1,80,25);textbackground(black);
  position:=anker;
  bildanf:=anker;
  bildend:=abstand(bildanf,19);
  repeat
    gotoxy(1,4);
    lauf:=bildanf;
    while ((lauf<>nil)and(lauf<>bildend^.vor)) do
    begin
      if lauf=position then
      begin
        textbackground(lightgreen); textcolor(white);
        write(lauf^.inhalt.name:20, lauf^.inhalt.tel:19,lauf^.inhalt.strasse:20,lauf^.inhalt.stadt:20,' ');
        textbackground(black); textcolor(lightgray);
      end
      else write(lauf^.inhalt.name:20, lauf^.inhalt.tel:19,lauf^.inhalt.strasse:20,lauf^.inhalt.stadt:20,' ');
      inc(i);
      lauf:=lauf^.vor;
    end;
    if wherey<25 then clreol; {falls geloescht: ueberschreiben}
    ch:='?';
    repeat              {Maus-Extra-Schleife}
      mauso(m);
      mausx:=(m[3] div 8+1); mausy:=(m[4] div 8+1);
      if test then
      begin
        gotoxy(1,1);
        write('x:',mausx:3,' y:',mausy:3);
      end;
      if m[2]=1 then
      begin
        repeat mauso(m); until m[2]=0;
        if mausy=25 then
        case mausx of
          18..22: ch:=char(27);
          26..31: ch:='S';
          35..37: ch:='H';
          39..41: ch:='P';
          45..47: ch:='N';
          49..51: ch:='T';
          53..55: ch:='A';
          57..59: ch:='W';
        end;
      end;
      if keypressed then ch:=readkey;
    until (ch<>'?');
    if anker <> nil then case ch of
      'N','T','A','W': datensatz_bearbeiten;
      'H':if (position^.zurueck<>nil) then
          begin
            if position=bildanf then
            begin
              bildanf:=bildanf^.zurueck;
              bildend:=bildend^.zurueck;
            end;
            position:=position^.zurueck;
          end;
      'P':if position^.vor<>nil then
          begin
            if position=bildend then
            begin
              bildanf:=bildanf^.vor;
              bildend:=bildend^.vor;
            end;
            position:=position^.vor;
          end;
      'a'..'z':if position<>nil then
        begin
          lauf:=anker;
          while ((upcase(lauf^.inhalt.name[1])<>upcase(ch))and(lauf<>nil))do
            lauf:=lauf^.vor;
          if(upcase(lauf^.inhalt.name[1])=upcase(ch)) then
          begin
            position:=lauf;
            bildanf:=anker;
            bildend:=abstand(bildanf,19);
            while ( (bildanf <> position) and (bildend <> position)
              and (bildend^.vor <> nil) ) do
            begin
              bildanf:=bildanf^.vor;
              bildend:=bildend^.vor;
            end;
          end;
        end;
      'S': if position<>nil then            {Loeschen}
           begin
             lauf:=position;
             if position^.zurueck=nil then  {Entweder Anfang...}
             begin
               position:=position^.vor;
               bildanf:=bildanf^.vor;
               if bildend^.vor<>nil then bildend:=bildend^.vor;
             end
             else                           {...oder Ende...}
             if position^.vor=nil then
             begin
               position:=position^.zurueck;
               if bildanf^.zurueck<>nil then bildanf:=bildanf^.zurueck;
               bildend:=bildend^.zurueck;
             end
             else                        {...oder "Normal"}
             if bildend^.vor<>nil then
             begin
               if bildanf=position then bildanf:=bildanf^.vor;
               bildend:=bildend^.vor;
               position:=position^.vor;
             end
             else
             begin
               position:=position^.zurueck;
               if bildanf^.zurueck<>nil then bildanf:=bildanf^.zurueck;
             end;
             loeschen(lauf);
           end;
      end; {von case}
  until ord(ch)=27;
end; {von procedure durchsehen}

procedure einfuegen(neu: zeiger);
var
  lauf: zeiger;
  ende: boolean;
begin
  ende:= false;
  lauf:= anker;
  repeat
    if gr(neu^.inhalt.name) < gr(lauf^.inhalt.name) then
    begin                   {vor lauf anfgen}
      neu^.vor:= lauf;
      neu^.zurueck:= lauf^.zurueck;
      if lauf^.zurueck = nil then anker:=neu
                             else lauf^.zurueck^.vor:= neu;
      lauf^.zurueck:= neu;
      ende:= true;
    end
    else
    if lauf^.vor = nil then
    begin                  {am Ende der List anfgen}
      lauf^.vor:= neu;
      neu^.vor:= nil;
      neu^.zurueck:= lauf;
      ende:= true;
    end
    else lauf:= lauf^.vor;
  until ende;
end;

procedure anfuegen;
var
  neu:zeiger;
begin
  csron;
  new(neu);
  neu^.vor:=nil;
  neu^.zurueck:=nil;
  neu^.inhalt.name := eingabeFeld('Name eingeben', 20);
  if neu^.inhalt.name = '' then dispose(neu) else
  begin
    with neu^.inhalt do
    begin
      tel := eingabeFeld( name + '''s Telefonnummer', 19 );
      strasse := eingabeFeld( name + '''s Strasse/Hausnummer', 20 );
      stadt := eingabeFeld( name + '''s Postleitzahl/Stadt', 20 );
    end;
    if anker=nil then anker:=neu else einfuegen(neu);
    writeln;
    angucken;
  end;
end;  {von procedure anfuegen}

procedure oeffnen2(name:string; importieren:boolean; var dateiname:string);
var
  datei:text;
  neu:zeiger;
  zeile:string[80];
  i,j:byte;

function getInhalt(pos1,pos2:byte):string;
var
  k: byte;
  hilfstring: string[20];
begin
  hilfstring := '';
  for k := pos1 to pos2 do
    if (k <= length(zeile)) and ((zeile[k] <> ' ') or ((zeile[k + 1] <> ' ') and (k < pos2))) then
      hilfstring := hilfstring + zeile[k];
  getInhalt := hilfstring;
end;
begin
  assign(datei,erweiterung(name,'.va'));
  {$I-}
  reset(datei);
  {$I+}
  if ioresult <> 0 then
  begin
    writeln('Die Datei ',erweiterung(name,'.va'), ' gibt',chr(39),'s nicht! Weiter mit >Enter<...');
    readln;
  end
  else
  begin
    while not eof(datei) do
    begin
      readln(datei,zeile);
      if zeile[1]<>' ' then
      begin
        new(neu);
        neu^.vor:=nil;
        neu^.zurueck:=nil;
        neu^.inhalt.name:=getInhalt(1,20);
        neu^.inhalt.tel:=getInhalt(21,39);
        neu^.inhalt.strasse:=getInhalt(40,59);
        neu^.inhalt.stadt:=getInhalt(60,79);
        writeln;
        write(neu^.inhalt.name);
        if not importieren then
        begin
          anker:=neu;
          importieren:=true;
          dateiname:=name;
        end
        else einfuegen(neu);
      end;
    end;
    close(datei);
  end;
end; {von procedure oeffnen2}

procedure oeffnen(importieren:boolean; var dateiname:string);
var
  name:string;
  ende:boolean;
begin
  csron; ende:=false;
  if anker=nil then importieren:=false;
  if (not(importieren)and(anker<>nil)) then
   if not entscheidung('Aktiver Datensatz geht verloren! Weiter? ',10,9,test)
   then ende:=true;
  if not ende then
  begin
    clrscr;
    dir('*.va ');
    write('ffnen - Dateiname (Pfadangabe mglich): ');
    readln(name);
    oeffnen2(name,importieren,dateiname);
  end;
end; {von procedure oeffnen}

procedure speichern(vorhanden: boolean; var dateiname:string);
var
  datei:text;
  lauf:zeiger;
  zeile:string[80];
  vorname:string;
begin
  if anker <> nil then
  begin
    if((not vorhanden)or(dateiname='')) then
    begin
      csron;
      dir('*.va ');
      write('Speichern - Dateiname (Pfadangabe mglich): ');
      readln(vorname);
      if vorname = '' then writeln('NICHT gespeichert!');
    end
    else vorname:=dateiname;
    if vorname <> '' then
      begin
      assign(datei,erweiterung(vorname,'.va'));
      {$I-}
      reset(datei);
      {$I+}
      if (ioresult=0) then
        if not entscheidung('Vorhandene Datei berschreiben?',10,11,test) then
        begin
          if entscheidung('Anderen Dateinamen eingeben?',10,12,test)
            then speichern(false,dateiname);
          exit;
        end;
      dateiname:=vorname;
      rewrite(datei);
      writeln(datei,'               Adressliste - '+nur_name(dateiname)+'                      '+datum);
      lauf:=anker;
      while lauf<>nil do
      begin
        write('.');
        with lauf^.inhalt do
          zeile := txtLaenge(name, 20) + txtLaenge(tel, 19)
                   + txtLaenge(strasse, 20) + txtLaenge(stadt, 20);
        writeln(datei,zeile);
        lauf:=lauf^.vor;
      end;
      close(datei);
      writeln;
      write('Datei wurde gespeichert!');
    end;
  end
  else write('Nichts da zum Speichern!');
end;   {von procedure speichern}

procedure drucken(dateiname:string);
const z=58;           {Zeile pro Seite}
var lauf:zeiger;
    seiten,seiten2,i:byte;
    zeile:string[80];
    ch:char;
begin
  if anker <> nil then
    begin
      lauf:=anker;
      seiten:=round(zaehlen/z);
      if seiten<(zaehlen/z)then inc(seiten); {Rundungsfehler?}
      seiten2:=1;
      write('Pro Seite werden bis zu ',z,' Namen gedruckt.');gotoxy(69,wherey);writeln(datum);
      writeln('Das Drucken wurde verbessert und getestet - jetzt sollte alles klappen!');
      writeln(^j,nur_name(dateiname),': ',zaehlen,' Namen, d.h. ',seiten,' Seite(n)! ');
      if entscheidung('Soll wirklich gedruckt werden?',10,12,test) then
        repeat
          zeile:=('                  Adressliste - '+nur_name(dateiname)+'                          '+datum);
          if seiten>1 then
          begin
            zeile:=zeile+(' (Seite '+int2str(seiten2)+' von '+int2str(seiten)+')');
            inc(seiten2);
          end;
          write('Daten werden zum Drucker geschickt - Seite ',seiten2,' von ',seiten);
          write(lst,chr(10),chr(10),chr(13));{Zeilenvorschub, Anfang d. Zeile}
          write(lst,zeile);
          write(lst,chr(10),chr(10),chr(13));
          i:=1;
          while ((lauf<>nil)and(i<=z)) do
            begin
              write('.');
              inc(i);
              with lauf^.inhalt do
                zeile := txtLaenge(name, 20) + txtLaenge(tel, 19)
                         + txtLaenge(strasse, 20) + txtLaenge(stadt, 20);
              write(lst, zeile, chr(10), chr(13));
              lauf:=lauf^.vor;
            end;
          writeln;
          write(lst,chr(10),chr(13),chr(12));            {Seitenvorschub}
        until lauf=nil;
    end
  else writeln('Es ist nichts da zum drucken!');
end; {von procedure drucken}

procedure main;
const
 mt:MenuText=(' Daten durchsehen ','  Daten anfgen   ',' Daten speichern  ',
              ' Speichern als... ','   Datei ffnen   ','   ...importiern  ',
              ' Datei drucken... ','     Beenden      ');
var
  ende:boolean;
  ch:char;
  dateiname,titel:string;
  menupos:byte;
begin
  menupos:=1;
  ende:=false;
  if ParamStr(1)<>'' then  {Kommandozeile auswerten}
    begin
      if ((paramstr(1)='-?')or(paramstr(1)='/?')) then
        begin
          writeln('Starten mit ''AdresXXX [Dateiname[.va]] [-test]''');
          writeln('Eine Taste drcken...');
          ch:=readkey;
          halt;
        end;
      if paramStr(2)='-test' then
        begin
          Writeln('Test-Modus aktiviert!',^j);
          test:=true;
        end
       else test:=false;
      Writeln('Versuche Datei ',erweiterung(ParamStr(1),'.va'), ' zu ffnen...');
      oeffnen2(ParamStr(1),false,dateiname);
    end
  else dateiname:='';
  IF Mem[MemW[0:$cc+2]:MemW[0:$cc]]=$cf THEN {Maus da?}
  begin
    textcolor(red);
    writeln('Maus nicht aktiviert!');
    writeln('Mouse.com aufrufen!');
  end
  else m[1]:=0; MausO(m);    {0 = Initialisierung}
  repeat
    m[1]:=1; MausO(m);       {1 = sichtbar machen}
    m[1]:=3; MausO(m);       {3 = Daten uebermitteln}
    if dateiname='' then titel:=VersionText else titel:=dateiname;
    case menu(mt,'Adressdatenbank - '+titel,menupos,8,22,6,36,test) of
      1: durchsehen(dateiname);
      2: anfuegen;
      3: speichern(true,dateiname);
      4: speichern(false,dateiname);
      5: oeffnen(false,dateiname);
      6: oeffnen(true,dateiname);
      7: drucken(dateiname);
      8: ende:=true;
    end;
  until ende;
  if anker<>nil then
    if entscheidung('Vor dem Beenden noch Speichern?',14,14,test) then
      speichern(TRUE, dateiname);
  window(1,1,80,25); textbackground(0); textcolor(7); clrscr; csron;
end;

begin
  anker:= nil;
  main;
  loescheAlle;
  writeln(^j, 'Tsch!');
end.